SystemOrganization addCategory: #TusLibros!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/9/2013 20:27'!
a20MinutesRemainingCart
	| aTimeStamp |
	aTimeStamp := TimeStamp now plusSeconds: (-600).
	^ TimedWrapper withWrappedObject: (self anEmptyCart) TimeStamp: aTimeStamp andTimeOutInSeconds: 1800.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/9/2013 20:32'!
aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor
	^ Cashier withPriceCatalog: self aPriceCatalogue  salesBook: aSalesBook andMerchantProcessor: aMerchantProcessor! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 21:50'!
aGoodPassword
	^ 'willr0x0rz'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 20:04'!
aMerchantProcessor
	^ ProductionMerchantProcessor new

! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/9/2013 21:07'!
aModelInterfaceWithCartsCatalog: aCartsCatalog
	^ ModelInterface withCartsCatalog: aCartsCatalog  usersCatalog: self aUsernameAndPasswordCatalog booksCatalog: self aPriceCatalogue andMerchantProcessor: self aPermissiveMerchantProcessor.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/9/2013 21:07'!
aModelInterfaceWithCartsCatalog: aCartsCatalog withMerchantProcessor: aMerchantProcessor 
	^ ModelInterface withCartsCatalog: aCartsCatalog  usersCatalog: self aUsernameAndPasswordCatalog booksCatalog: self aPriceCatalogue andMerchantProcessor: aMerchantProcessor.
	! !

!TusLibrosTest methodsFor: '1 - Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 21:09'!
aNonCataloguedTestBook 
	^ '3'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/9/2013 20:27'!
aNonTimedOutCart
	| aTimeStamp |
	aTimeStamp := TimeStamp now.
	^ TimedWrapper withWrappedObject: (self anEmptyCart) TimeStamp: aTimeStamp andTimeOutInSeconds: 1800.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 20:14'!
aPermissiveMerchantProcessor
	^ PermissiveMerchantProcessor new! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/29/2013 21:25'!
aPriceCatalogue 
	^ Dictionary newFromPairs: {self aTestBook. 10. self anotherTestBook. 30}! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 20:03'!
aRejectiveMerchantProcessor
	^ RejectiveMerchantProcessor new! !

!TusLibrosTest methodsFor: '1 - Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 21:09'!
aTestBook 
	^ '1'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 19:12'!
aTestClient
	^ 'Will Smith'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/9/2013 20:27'!
aTimedOutCart
	| aTimeStamp |
	aTimeStamp := TimeStamp now plusSeconds: (-1801).
	^ TimedWrapper withWrappedObject: (self anEmptyCart) TimeStamp: aTimeStamp andTimeOutInSeconds: 1800.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 21:34'!
aUsernameAndPasswordCatalog
	^ Dictionary newFromPairs: { 'Will Smith'. 'willr0x0rz'. 'Tommy Lee Jones'. 'mib2rulz' }! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 17:07'!
aValidCreditCard
	^ CreditCard createWithExpirationDate: (Date today addDays: 2) ownerName: 'Will Smith' andBin: '1234'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/9/2013 13:11'!
aValidCreditCardsCatalogue
	^ Dictionary newFromPairs: {'1234123412341234'.  CreditCard createWithExpirationDate: (Date today addDays: 2) ownerName: 'Will Smith' andBin: '1234123412341234'}
! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 21:23'!
aValidUsername
	^ 'Will Smith'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 21:23'!
aWrongPassword
	^ '12345'! !

!TusLibrosTest methodsFor: '1 - Cart' stamp: 'EtchegoyenLajePulver 6/9/2013 20:18'!
anEmptyCart
	^ Cart withCatalog: self aPriceCatalogue ! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 21:17'!
anEmptyCartsCatalog
	^ Dictionary new.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 19:14'!
anEmptySalesBook
	^ SalesBook new! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 21:49'!
anInvalidUsername
	^ 'Ddasdsad'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 17:04'!
anOutOfDateCreditCard
	^ CreditCard createWithExpirationDate: (Date today addDays: -2) ownerName: 'John' andBin: '123'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/9/2013 10:10'!
anOutOfDateCreditCardsCatalogue
	^ Dictionary newFromPairs: {'123'. 	 CreditCard createWithExpirationDate: (Date today addDays: -2) ownerName: 'John' andBin: '123'}
	
! !

!TusLibrosTest methodsFor: '1 - Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 21:09'!
anotherTestBook 
	^ '2'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 19:13'!
anotherTestClient
	^ 'Tommy Lee Jones'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 19:11'!
anotherValidCreditCard
	^ CreditCard createWithExpirationDate: (Date today addDays: 2) ownerName: 'Tommy Lee Jones' andBin: '12345'! !

!TusLibrosTest methodsFor: '1 - Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test01NewCartShouldBeEmpty
	self assert: self anEmptyCart isEmpty! !

!TusLibrosTest methodsFor: '1 - Cart' stamp: 'EtchegoyenLajePulver 6/9/2013 21:26'!
test02BookShouldBePresentAfterBeingAdded
	|aCart|
	aCart:= self anEmptyCart.
	aCart add: self aTestBook.
	
	self assert: (aCart includes: self aTestBook)! !

!TusLibrosTest methodsFor: '1 - Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test03CartShouldNotBeEmptyAfterAddingBook
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	aCart add: aBook.
	
	self deny: (aCart isEmpty)! !

!TusLibrosTest methodsFor: '1 - Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test04EmptyCartHasSize0
	|aCart|
	aCart:= self anEmptyCart.
	self assert: (aCart size = 0)! !

!TusLibrosTest methodsFor: '1 - Cart' stamp: 'EtchegoyenLajePulver 6/9/2013 21:27'!
test05EachAddedBookIncreasesCartSize
	|aCart|
	aCart:= self anEmptyCart.
	
	self assert: (aCart size = 0).
	aCart add: self aTestBook.
	self assert: (aCart size = 1).
	aCart add: self anotherTestBook.
	self assert: (aCart size = 2).! !

!TusLibrosTest methodsFor: '1 - Cart' stamp: 'EtchegoyenLajePulver 6/9/2013 21:28'!
test06OnlyAddedBooksShouldBePresent
	|aCart|
	aCart:= self anEmptyCart.
	aCart add: self aTestBook.
	
	self assert: (aCart includes: self aTestBook).
	self deny: (aCart includes: self anotherTestBook).
	self assert: (aCart size = 1)! !

!TusLibrosTest methodsFor: '1 - Cart' stamp: 'EtchegoyenLajePulver 6/9/2013 21:28'!
test07BookNotAddedToCartHasNoOcurrencesInCart
	|aCart|
	aCart:= self anEmptyCart.
	
	self assert: ((aCart occurrencesOf: self aTestBook) = 0)! !

!TusLibrosTest methodsFor: '1 - Cart' stamp: 'EtchegoyenLajePulver 6/9/2013 21:29'!
test08EachBookAddedToCartIncreasesOccurrencesInCart
	|aCart|
	aCart:= self anEmptyCart.
	
	aCart add: self aTestBook.
	self assert: ((aCart occurrencesOf: self aTestBook) = 1).
	aCart add: self aTestBook.
	self assert: ((aCart occurrencesOf: self aTestBook) = 2).
	self assert: ((aCart occurrencesOf: self anotherTestBook) = 0)! !

!TusLibrosTest methodsFor: '1 - Cart' stamp: 'EtchegoyenLajePulver 6/9/2013 21:30'!
test09AddingBooksWithQuantityIncreasesOccurrencesSameQuantity
	|aCart|
	aCart:= self anEmptyCart.

	aCart add: self aTestBook.
	aCart add: self aTestBook withOccurrences: 9.
	self assert: ((aCart occurrencesOf: self aTestBook) = 10).! !

!TusLibrosTest methodsFor: '1 - Cart' stamp: 'EtchegoyenLajePulver 6/9/2013 21:30'!
test10NonCataloguedBooksShouldntBeAbleToBeAdded
	|aCart|
	aCart:= self anEmptyCart.
		
	self should: [aCart add: self aNonCataloguedTestBook] raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cart nonCatalogedBookDescription ].
! !

!TusLibrosTest methodsFor: '1 - Cart' stamp: 'EtchegoyenLajePulver 6/9/2013 21:31'!
test10bOnlyNaturalQuantityIsAllowedWhenAddingToCart
	|aCart anAllowedQuantity anotherAllowedQuantity aForbiddenQuantity anotherForbiddenQuantity |
	aCart:= self anEmptyCart.
	anAllowedQuantity := 1.	
	anotherAllowedQuantity := 10.			
	aForbiddenQuantity := 0.	
	anotherForbiddenQuantity := -1.	

	self should: [aCart add: self aTestBook withOccurrences: aForbiddenQuantity] raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cart forbiddenQuantityDescription ].			
	self should: [aCart add: self aTestBook withOccurrences: anotherForbiddenQuantity] raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cart forbiddenQuantityDescription ].		
		
	self shouldnt: [aCart add: self aTestBook withOccurrences: anAllowedQuantity] raise: Error.			
	self shouldnt: [aCart add: self aTestBook withOccurrences: anotherAllowedQuantity] raise: Error.					

! !

!TusLibrosTest methodsFor: '2 - Cashier and Sale' stamp: 'EtchegoyenLajePulver 6/9/2013 21:34'!
test11ShouldntBeAbleToCheckOutEmptyCart
	| aCart aCashier  |
	aCart := self anEmptyCart.
	aCashier := self aCashierWithSalesBook: self anEmptySalesBook andMerchantProcessor: self aMerchantProcessor.
		
	self should: [aCashier checkout: aCart withCreditCard: self aValidCreditCard andClient: self aTestClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier cartEmptyErrorDescription ]! !

!TusLibrosTest methodsFor: '2 - Cashier and Sale' stamp: 'EtchegoyenLajePulver 6/9/2013 21:35'!
test12ShouldntBeAbleToCheckOutWithOutOfDateCreditCard
	| aCart aCashier |
	
	aCart := self anEmptyCart.
	aCashier := self aCashierWithSalesBook: self anEmptySalesBook andMerchantProcessor: self aMerchantProcessor.
		
	aCart add: self aTestBook.
	
	self should: [aCashier checkout: aCart withCreditCard: self anOutOfDateCreditCard andClient: self aTestClient ]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier outOfDateCreditCardErrorDescription ]! !

!TusLibrosTest methodsFor: '2 - Cashier and Sale' stamp: 'EtchegoyenLajePulver 6/9/2013 21:36'!
test13CashierShouldCalculateRightTotalAmount
	|aCart aCashier|

	aCart := self anEmptyCart.
	aCashier := self aCashierWithSalesBook: self anEmptySalesBook andMerchantProcessor: self aMerchantProcessor.
	aCart add: self aTestBook.
	aCart add: self anotherTestBook.
	
	self assert: ((aCashier checkout: aCart withCreditCard: self aValidCreditCard andClient: self aTestClient ) amount = 40).
	
	aCart add: self aTestBook.
	
	self assert: ((aCashier checkout: aCart withCreditCard: self aValidCreditCard andClient: self aTestClient) amount = 50)! !

!TusLibrosTest methodsFor: '2 - Cashier and Sale' stamp: 'EtchegoyenLajePulver 6/9/2013 21:37'!
test14CashierShouldWriteSaleToSalesBook
	| aCart aCashier aSalesBook sale1 sale2|

	aCart := self anEmptyCart.
	aSalesBook:= self anEmptySalesBook.
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: self aPermissiveMerchantProcessor.
	
	aCart add: self aTestBook.
	aCart add: self anotherTestBook.
	
	self assert: (aSalesBook size = 0).
	sale1 := aCashier checkout: aCart withCreditCard: self aValidCreditCard andClient: self aTestClient.
	self assert: (aSalesBook size = 1).
	sale2:= aCashier checkout: aCart withCreditCard: self aValidCreditCard andClient: self aTestClient.
	self assert: (aSalesBook size = 2).
	self assert: (aSalesBook includes: sale1).
	self assert: (aSalesBook includes: sale2).! !

!TusLibrosTest methodsFor: '2 - Cashier and Sale' stamp: 'EtchegoyenLajePulver 6/9/2013 21:39'!
test15CashierShouldntCreateSaleWhenPaymentErrorsOccurred
	| aCart aCashier aSalesBook|
	
	aCart := self anEmptyCart.
	aSalesBook:= self anEmptySalesBook.
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: self aPermissiveMerchantProcessor.
	
	self should: [aCashier checkout: aCart withCreditCard: self aValidCreditCard andClient: self aTestClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier cartEmptyErrorDescription ].
	
	self assert: (aSalesBook size = 0).
	
	aCart add: self aTestBook.
	self should: [aCashier checkout: aCart withCreditCard: self anOutOfDateCreditCard andClient: self aTestClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier outOfDateCreditCardErrorDescription ].
	
	self assert: (aSalesBook size = 0).! !

!TusLibrosTest methodsFor: '3 - SalesBook' stamp: 'EtchegoyenLajePulver 6/9/2013 21:43'!
test16SalesBookShouldKnowAClientSales
	| aCart aCashier aSalesBook sale1 sale2 sale3 |
	
	aCart := self anEmptyCart.
	aSalesBook:= self anEmptySalesBook.
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: self aPermissiveMerchantProcessor.
	
	self assert: ((aSalesBook purchasesFrom: self aTestClient) size = 0).
	self assert: ((aSalesBook purchasesFrom: self anotherTestClient) size = 0).
	
	aCart add: self aTestBook.
	sale1:= aCashier checkout: aCart withCreditCard: self aValidCreditCard andClient: self aTestClient.
	sale2:= aCashier checkout: aCart withCreditCard: self aValidCreditCard andClient: self aTestClient.	
	sale3:= aCashier checkout: aCart withCreditCard: self anotherValidCreditCard andClient: self anotherTestClient.
	
	self assert: ((aSalesBook purchasesFrom: self aTestClient) size = 2).
	self assert: ((aSalesBook purchasesFrom: self anotherTestClient) size = 1).
	
	self assert: ((aSalesBook purchasesFrom: self aTestClient) includes: sale1).
	self assert: ((aSalesBook purchasesFrom: self aTestClient) includes: sale2).
	self assert: ((aSalesBook purchasesFrom: self anotherTestClient) includes: sale3).
	
	self deny: ((aSalesBook purchasesFrom: self anotherTestClient) includes: sale1).
	self deny: ((aSalesBook purchasesFrom: self anotherTestClient) includes: sale2).
	self deny: ((aSalesBook purchasesFrom: self aTestClient) includes: sale3).
	
	! !

!TusLibrosTest methodsFor: '2 - Cashier and Sale' stamp: 'EtchegoyenLajePulver 6/9/2013 21:45'!
test17CashierShouldntBeAbleToCheckoutWithCreditCardAndClientNameMismatch
	| aCart aCashier aSalesBook |

	aCart := self anEmptyCart.
	aSalesBook:= self anEmptySalesBook.
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: self aPermissiveMerchantProcessor.
	
	aCart add: self aTestBook.
	
	self should: [aCashier checkout: aCart withCreditCard: self aValidCreditCard andClient: self anotherTestClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier creditCardNameMismatchDescription ].
	
	self assert: (aSalesBook size = 0).! !

!TusLibrosTest methodsFor: '5 - TimedWrapper' stamp: 'EtchegoyenLajePulver 6/9/2013 20:26'!
test18CartShouldBeInvalidAfterTimeOutTimePassed
	| aCart |
	aCart := self aTimedOutCart.
	
	self should: [aCart add: self aTestBook]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = TimedWrapper timeOutDescription ].! !

!TusLibrosTest methodsFor: '5 - TimedWrapper' stamp: 'EtchegoyenLajePulver 6/3/2013 17:17'!
test19CartShouldNotBeInvalidBeforeTimeOutTimePassed
	| aCart |
	aCart := self aNonTimedOutCart.
	
	self shouldnt: [ aCart add: self aTestBook ] raise: Error! !

!TusLibrosTest methodsFor: '5 - TimedWrapper' stamp: 'EtchegoyenLajePulver 6/3/2013 17:21'!
test20NonTimedOutCartShouldBeAbleToRespondEveryCartMessage
	| aCart |
	aCart := self aNonTimedOutCart.
	
	self shouldnt: [ aCart add: self aTestBook ] raise: Error.
	self shouldnt: [ aCart add: self aTestBook withOccurrences: 1] raise: Error.
	self shouldnt: [ aCart includes: self aTestBook ] raise: Error.
	self shouldnt: [ aCart isEmpty] raise: Error.
	self shouldnt: [ aCart occurrencesOf: self aTestBook ] raise: Error.
	self shouldnt: [ aCart size] raise: Error.! !

!TusLibrosTest methodsFor: '5 - TimedWrapper' stamp: 'EtchegoyenLajePulver 6/3/2013 17:44'!
test21EveryOperationShouldResetCartTimeToLive
	| aCart |
	
	aCart := self a20MinutesRemainingCart.
	self assert: (aCart minutesToLive = 20).
	aCart add: self aTestBook.
	self assert: (aCart minutesToLive = 30).
	
	aCart := self a20MinutesRemainingCart.
	self assert: (aCart minutesToLive = 20).
	aCart add: self aTestBook withOccurrences: 1.
	self assert: (aCart minutesToLive = 30).
	
	aCart := self a20MinutesRemainingCart.
	self assert: (aCart minutesToLive = 20).
	aCart includes: self aTestBook.
	self assert: (aCart minutesToLive = 30).
	
	aCart := self a20MinutesRemainingCart.
	self assert: (aCart minutesToLive = 20).
	aCart isEmpty.
	self assert: (aCart minutesToLive = 30).
	
	aCart := self a20MinutesRemainingCart.
	self assert: (aCart minutesToLive = 20).
	aCart occurrencesOf: self aTestBook.
	self assert: (aCart minutesToLive = 30).! !

!TusLibrosTest methodsFor: '2 - Cashier and Sale' stamp: 'EtchegoyenLajePulver 6/9/2013 21:48'!
test22CashierShouldntCallMerchantProcessorWhenCardIsExpired
      | aCart aCashier aMerchantProcessor |
	
	aCart := self anEmptyCart.
	aMerchantProcessor := self aMerchantProcessor.
	aCashier := self aCashierWithSalesBook: self anEmptySalesBook andMerchantProcessor: aMerchantProcessor.
	
	aCart add: self aTestBook.
	aCart add: self anotherTestBook.
	
	self assert: ( aMerchantProcessor requestsCount = 0 ).
	
	self should: [ aCashier checkout: aCart withCreditCard: self anOutOfDateCreditCard andClient: self aTestClient ]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier outOfDateCreditCardErrorDescription ].
	
	self assert: ( aMerchantProcessor requestsCount = 0 ).! !

!TusLibrosTest methodsFor: '2 - Cashier and Sale' stamp: 'EtchegoyenLajePulver 6/9/2013 21:49'!
test23CashierShouldntCallMerchantProcessorWhenCartIsEmpty
      | aCart aCashier aMerchantProcessor |

	aCart := self anEmptyCart.
	aMerchantProcessor := self aMerchantProcessor.
	aCashier := self aCashierWithSalesBook: self anEmptySalesBook andMerchantProcessor: aMerchantProcessor.
	
	
	self assert: ( aMerchantProcessor requestsCount = 0 ).
	
	self should: [aCashier checkout: aCart withCreditCard: self aValidCreditCard andClient: self aTestClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier cartEmptyErrorDescription ].
	
	self assert: ( aMerchantProcessor requestsCount = 0 ).! !

!TusLibrosTest methodsFor: '2 - Cashier and Sale' stamp: 'EtchegoyenLajePulver 6/9/2013 21:50'!
test24CashierShouldntCallMerchantProcessorWithCreditCardAndClientNameMismatch
	| aCart aCashier aMerchantProcessor |

	aCart := self anEmptyCart.
	aMerchantProcessor := self aMerchantProcessor.
	aCashier := self aCashierWithSalesBook: self anEmptySalesBook andMerchantProcessor: aMerchantProcessor.
	aCart add: self aTestBook.
	
	self assert: ( aMerchantProcessor requestsCount = 0 ).
	
	self should: [aCashier checkout: aCart withCreditCard: self aValidCreditCard andClient: self anotherTestClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier creditCardNameMismatchDescription ].
	
	self assert: ( aMerchantProcessor requestsCount = 0 ).! !

!TusLibrosTest methodsFor: '2 - Cashier and Sale' stamp: 'EtchegoyenLajePulver 6/9/2013 21:53'!
test25CashierShouldCallMerchantProcessorWhenAttemptingValidSale
	| aCart aCashier aMerchantProcessor |

	aCart := self anEmptyCart.
	aMerchantProcessor := self aPermissiveMerchantProcessor.
	aCashier := self aCashierWithSalesBook: self anEmptySalesBook andMerchantProcessor: aMerchantProcessor.
		
	aCart add: self aTestBook.
	
	"se verifica que el carrito no este vacio, la tarjeta no haya expirado y pertenezca al cliente"
	self deny: aCart isEmpty. 
	self deny: self aValidCreditCard isDue. 
	self assert: (self aValidCreditCard name = self aTestClient).
	
	self assert: (aMerchantProcessor requestsCount = 0).	
	aCashier checkout: aCart withCreditCard: self aValidCreditCard andClient: self aTestClient .
	self assert: (aMerchantProcessor requestsCount = 1).
	aCashier checkout: aCart withCreditCard: self aValidCreditCard andClient: self aTestClient.
	self assert: (aMerchantProcessor requestsCount = 2).
	! !

!TusLibrosTest methodsFor: '2 - Cashier and Sale' stamp: 'EtchegoyenLajePulver 6/9/2013 21:55'!
test26CashierShouldntCreateSaleWhenMerchantProcessorCantDebit
	| aCart aCashier aSalesBook aMerchantProcessor|
	
	aCart := self anEmptyCart.
	aMerchantProcessor := self aRejectiveMerchantProcessor.
	aSalesBook := self anEmptySalesBook. 
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
	
	aCart add: self aTestBook.	

	
	self assert: (aSalesBook size = 0).
	self assert: (aMerchantProcessor requestsCount = 0).
	
	self should: [aCashier checkout: aCart withCreditCard: self aValidCreditCard andClient: self aTestClient.]  raise: Error withExceptionDo: [:anError | self assert: anError messageText =MerchantProcessor rejectedOperationDescription ].
	
	self assert: (aSalesBook size = 0).
	self assert: (aMerchantProcessor requestsCount = 1).! !

!TusLibrosTest methodsFor: '2 - Cashier and Sale' stamp: 'EtchegoyenLajePulver 6/9/2013 21:56'!
test27CashierShouldCreateSaleWhenMerchantProcessorCanDebit
	| aCart aCashier aMerchantProcessor aSalesBook |
	
	aCart := self anEmptyCart.
	aMerchantProcessor := self aPermissiveMerchantProcessor.
	aSalesBook := self anEmptySalesBook. 
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
	aCart add: self aTestBook.	

	self assert: (aSalesBook size = 0).
	self assert: (aMerchantProcessor requestsCount = 0).
	
	self shouldnt: [aCashier checkout: aCart withCreditCard: self aValidCreditCard andClient: self aTestClient.]  raise: Error.
	
	
	self assert: (aSalesBook size = 1).
	self assert: (aMerchantProcessor requestsCount = 1).! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/5/2013 21:22'!
test28ModelInterfaceShouldntCreateNewCartWhenInvalidUsernamePassword
	| aModelInterface aCartsCatalog |

	aCartsCatalog := self anEmptyCartsCatalog.
	aModelInterface := self aModelInterfaceWithCartsCatalog: aCartsCatalog .
	
	self assert: (aCartsCatalog size = 0).
	
	self should: [ aModelInterface createCartWithClientid: self aValidUsername andPassword: self aWrongPassword ] raise: Error withExceptionDo: [:anError | self assert: anError messageText = aModelInterface class wrongUserOrPassword ].
	self should: [ aModelInterface createCartWithClientid: self anInvalidUsername andPassword: self aGoodPassword ] raise: Error withExceptionDo: [:anError | self assert: anError messageText = aModelInterface class wrongUserOrPassword ].
	
	self assert: (aCartsCatalog size = 0).
	! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/7/2013 20:13'!
test29ModelInterfaceShouldCreateNewCartWhenValidUsernamePassword
	| aModelInterface aCartsCatalog |

	aCartsCatalog := self anEmptyCartsCatalog.
	aModelInterface := self aModelInterfaceWithCartsCatalog: aCartsCatalog .
	
	self assert: (aCartsCatalog size = 0).
	
	self shouldnt: [ aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword ] raise: Error.
	
	self assert: (aCartsCatalog size = 1).
	! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 22:12'!
test30ModelInterfaceShouldReturnDifferentIdsWhenCreatingCarts
	| aModelInterface aCartId anotherCartId yetAnotherCartId |

	aModelInterface := self aModelInterfaceWithCartsCatalog: self anEmptyCartsCatalog .
	
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	anotherCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	yetAnotherCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	
	self deny: (aCartId = anotherCartId).
	self deny: (aCartId = yetAnotherCartId).
	self deny: (anotherCartId = yetAnotherCartId).
	! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 22:16'!
test31ModelInterfaceShouldNotBeAbleToAddNonCatalogedBook
	| aModelInterface aCartId |

	aModelInterface := self aModelInterfaceWithCartsCatalog: self anEmptyCartsCatalog.
	
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	self should: [ aModelInterface add: self aNonCataloguedTestBook withQuantity: 1 toCart: aCartId  ] raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cart nonCatalogedBookDescription ].! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 22:18'!
test32ModelInterfaceShouldNotBeAbleToAddBookToNonExistentCart
	| aModelInterface aCartId anInexistentCartId |

	aModelInterface := self aModelInterfaceWithCartsCatalog: self anEmptyCartsCatalog .
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	anInexistentCartId := aCartId +1.
	
	self should: [ aModelInterface add: self aTestBook withQuantity: 1 toCart: anInexistentCartId  ] raise: Error withExceptionDo: [:anError | self assert: anError messageText = ModelInterface inexistentCartDescription ].! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 22:21'!
test32bModelInterfaceShouldNotBeAbleToAddNonPositiveQuantitiesOfABookToCart
	| aModelInterface aCartId aNonPositiveQuantity anotherNonPositiveQuantity |

	aModelInterface := self aModelInterfaceWithCartsCatalog: self anEmptyCartsCatalog .
	aNonPositiveQuantity := 0.
	anotherNonPositiveQuantity := -1.	
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	
	self should: [ aModelInterface add: self aTestBook withQuantity: aNonPositiveQuantity toCart: aCartId  ] raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cart forbiddenQuantityDescription ].
	self should: [ aModelInterface add: self aTestBook withQuantity: anotherNonPositiveQuantity toCart: aCartId  ] raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cart forbiddenQuantityDescription ].! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 22:22'!
test33ModelInterfaceShouldBeAbleToAddCatalogedBookToExistentCart
	| aModelInterface aCartId aPositiveQuantity |

	aModelInterface := self aModelInterfaceWithCartsCatalog: self anEmptyCartsCatalog .
	aPositiveQuantity := 1.
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	
	self shouldnt: [ aModelInterface add: self aTestBook withQuantity: aPositiveQuantity toCart: aCartId  ] raise: Error.! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 22:25'!
test34ModelInterfaceShouldReturnEveryBookAddedToCartWhenListingCart
	| aModelInterface aCartId books |

	aModelInterface := self aModelInterfaceWithCartsCatalog: self anEmptyCartsCatalog .
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.

	aModelInterface add: self aTestBook withQuantity:  8 toCart: aCartId.
	aModelInterface add: self anotherTestBook withQuantity:  5 toCart: aCartId.

	books := aModelInterface listCart: aCartId .
	
	self assert: ((books at: self aTestBook) = 8).
	self assert: ((books at: self anotherTestBook) = 5).
	self assert: books size = 2.! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 22:26'!
test35ModelInterfaceShouldntListInexistentCart
	| aModelInterface aCartId anInexistentCartId |

	aModelInterface := self aModelInterfaceWithCartsCatalog: self anEmptyCartsCatalog .
	
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	anInexistentCartId := aCartId + 1.
	
	self should: [ aModelInterface listCart: anInexistentCartId ] raise: Error withExceptionDo: [ :anError | self assert: anError messageText = ModelInterface inexistentCartDescription ]! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 22:35'!
test36ModelInterfaceShouldntCheckoutInexistentCart
	| aModelInterface aCartId anInexistentCartId |

	aModelInterface := self aModelInterfaceWithCartsCatalog: self anEmptyCartsCatalog.
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	anInexistentCartId := aCartId + 1.

	self should: [ aModelInterface checkout: anInexistentCartId ccn: self aValidCreditCard bin cced: self aValidCreditCard expirationDate cco: self aValidCreditCard name ] raise: Error 	withExceptionDo: [:anError | self assert: anError messageText = ModelInterface inexistentCartDescription ].! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 22:46'!
test36bModelInterfaceShouldntCheckoutEmptyCart
	| aModelInterface aCartId |

	aModelInterface := self aModelInterfaceWithCartsCatalog: self anEmptyCartsCatalog.
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.

	self should: [ aModelInterface checkout: aCartId ccn: self aValidCreditCard bin cced: self aValidCreditCard expirationDate cco: self aValidCreditCard name ] raise: Error 	withExceptionDo: [:anError | self assert: anError messageText = Cashier cartEmptyErrorDescription ].! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 22:40'!
test37ModelInterfaceShouldntCheckoutWithExpiredCreditCardNumber

	| aModelInterface aCreditCard aCartId |
	aModelInterface := self aModelInterfaceWithCartsCatalog: self anEmptyCartsCatalog.
	aCreditCard :=	self anOutOfDateCreditCard.
		
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	aModelInterface add: self aTestBook withQuantity: 1 toCart: aCartId.
		
	self should: [ aModelInterface checkout: aCartId ccn: aCreditCard bin cced: aCreditCard expirationDate cco: aCreditCard name ] raise: Error
	withExceptionDo: [:anError | self assert: anError messageText = Cashier outOfDateCreditCardErrorDescription ]
	
		
	



! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 22:42'!
test38ModelInterfaceShouldntCheckoutWhenMerchantProcessorDeniesOperation

	| aModelInterface aCreditCard aCartId |
	
	aModelInterface := self aModelInterfaceWithCartsCatalog: self anEmptyCartsCatalog withMerchantProcessor: self aRejectiveMerchantProcessor.
	aCreditCard :=	self aValidCreditCard.
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	aModelInterface add: self aTestBook withQuantity: 1 toCart: aCartId.
	
	self should: [ aModelInterface checkout: aCartId ccn: aCreditCard bin cced: aCreditCard expirationDate cco: aCreditCard name ] raise: Error
	withExceptionDo: [:anError | self assert: anError messageText = MerchantProcessor rejectedOperationDescription ].

	
		
	



! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 22:48'!
test39ModelInterfaceShouldCheckoutWhenMerchantProcessorCanDebit

	| aModelInterface aCreditCard aCartId |
	
	aModelInterface := self aModelInterfaceWithCartsCatalog: self anEmptyCartsCatalog withMerchantProcessor: self aPermissiveMerchantProcessor.
	aCreditCard :=	self aValidCreditCard.

	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	aModelInterface add: self aTestBook withQuantity: 1 toCart: aCartId.
	
	self shouldnt: [ aModelInterface checkout: aCartId ccn: aCreditCard bin cced: aCreditCard expirationDate cco: aCreditCard name ] raise: Error! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 22:51'!
test39bModelInterfaceShouldReturnDifferentTransactionIdsForEveryCheckout

	| aModelInterface aCreditCard aCartId sale1 sale2 sale3 |
	
	aModelInterface := self aModelInterfaceWithCartsCatalog: self anEmptyCartsCatalog withMerchantProcessor: self aPermissiveMerchantProcessor.
	aCreditCard :=	self aValidCreditCard.

	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	aModelInterface add: self aTestBook withQuantity: 1 toCart: aCartId.
	
	sale1 := aModelInterface checkout: aCartId ccn: aCreditCard bin cced: aCreditCard expirationDate cco: aCreditCard name.
	sale2 := aModelInterface checkout: aCartId ccn: aCreditCard bin cced: aCreditCard expirationDate cco: aCreditCard name.
	sale3 := aModelInterface checkout: aCartId ccn: aCreditCard bin cced: aCreditCard expirationDate cco: aCreditCard name.
	
	self deny: sale1 = sale2.
	self deny: sale1 = sale3.
	self deny: sale2 = sale3.! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 19:00'!
test40ModelInterfaceShouldReturnErrorWhenListingPurchasesWithWrongLoginInformation

	| aModelInterface |
	
	aModelInterface := self aModelInterfaceWithCartsCatalog:	 self anEmptyCartsCatalog.
	
	self should: [ aModelInterface listPurchasesFromClient: self aValidUsername withPassword: self aWrongPassword ] raise: Error withExceptionDo: [ :error | self assert: error messageText = ModelInterface wrongUserOrPassword ].
	
	self should: [ aModelInterface listPurchasesFromClient: self anInvalidUsername withPassword: self aGoodPassword ] raise: Error withExceptionDo: [ :error | self assert: error messageText = ModelInterface wrongUserOrPassword ].

	self should: [ aModelInterface listPurchasesFromClient: self anInvalidUsername withPassword: self aWrongPassword ] raise: Error withExceptionDo: [ :error | self assert: error messageText = ModelInterface wrongUserOrPassword ]! !

!TusLibrosTest methodsFor: '4 - ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 20:24'!
test41ModelInterfaceShouldReturnEveryBookBoughtByClientAndTotalAmountWhenListingPurchases

	| aModelInterface aCartId boughtBooks boughtTotalAmount aValidCreditCard |
	
	aModelInterface := self aModelInterfaceWithCartsCatalog:	 self anEmptyCartsCatalog  withMerchantProcessor: self aPermissiveMerchantProcessor .
	
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	
	aModelInterface add: self aTestBook withQuantity: 3 toCart: aCartId.
	aModelInterface add: self anotherTestBook withQuantity: 2 toCart: aCartId.
	aValidCreditCard := self aValidCreditCard.
	
	aModelInterface checkout: aCartId  ccn: aValidCreditCard bin cced: aValidCreditCard expirationDate cco: aValidCreditCard name.
	aModelInterface checkout: aCartId  ccn: aValidCreditCard bin cced: aValidCreditCard expirationDate cco: aValidCreditCard name.
	
	boughtBooks := (aModelInterface listPurchasesFromClient: self aValidUsername withPassword: self aGoodPassword) at: 1.
	boughtTotalAmount := (aModelInterface listPurchasesFromClient: self aValidUsername withPassword: self aGoodPassword) at: 2.
	
	self assert: ((boughtBooks at: self aTestBook) = 6).
	self assert: ((boughtBooks at: self anotherTestBook) = 4).
	self assert: boughtBooks size = 2.
	self assert: (boughtTotalAmount = ( ( self aPriceCatalogue at: self aTestBook ) * 6 + ( ( self aPriceCatalogue at: self anotherTestBook ) * 4) ) )! !

Object subclass: #Cart
	instanceVariableNames: 'items catalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 6/9/2013 01:56'!
forbiddenQuantityDescription
	^ 'Only positive quantities allowed'! !

!Cart class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 6/9/2013 20:19'!
nonCatalogedBookDescription
	^ 'Catalog doesnt contain item'! !

!Cart class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/9/2013 20:22'!
withCatalog: aCatalog 
	^ self new initializeEmptyWithCatalog: aCatalog! !

!Cart methodsFor: 'adding' stamp: 'EtchegoyenLajePulver 5/29/2013 21:06'!
add: anItem
	self add: anItem withOccurrences: 1.! !

!Cart methodsFor: 'adding' stamp: 'EtchegoyenLajePulver 6/9/2013 20:22'!
add: anItem  withOccurrences: anInteger
	catalog at: anItem ifPresent: [ :aValue |  ] ifAbsent:  [^Error signal: self class nonCatalogedBookDescription ].
	anInteger < 1 ifTrue: [^Error signal: self class forbiddenQuantityDescription ].
	items add: anItem withOccurrences: anInteger! !

!Cart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:25'!
includes: anItem
	^ items includes: anItem! !

!Cart methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/9/2013 20:22'!
initializeEmptyWithCatalog: aCatalog
	items:= Bag new.
	catalog:= aCatalog! !

!Cart methodsFor: 'enumerating' stamp: 'EtchegoyenLajePulver 6/1/2013 18:02'!
inject: aValue into: aBinaryBlock
	^ items inject: aValue into: aBinaryBlock ! !

!Cart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:21'!
isEmpty
	^ items isEmpty ! !

!Cart methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:40'!
occurrencesOf: anItem
	^ items occurrencesOf: anItem ! !

!Cart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:29'!
size
	^ items size! !

!Cart methodsFor: 'iterating' stamp: 'EtchegoyenLajePulver 6/7/2013 21:53'!
withItemsAndQuantitiesDo: aBlockClosure 
	^ items valuesAndCounts associationsDo: [:assoc | aBlockClosure value: (assoc key) value: (assoc value) ]! !

Object subclass: #Cashier
	instanceVariableNames: 'salesBook merchantProcessor priceCatalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 5/29/2013 21:28'!
cartEmptyErrorDescription
	^ 'Cannot check out empy cart'! !

!Cashier class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 6/1/2013 19:39'!
creditCardNameMismatchDescription 
	^ 'credit card and client names mismatch'! !

!Cashier class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 6/1/2013 17:14'!
outOfDateCreditCardErrorDescription
	^ 'Invalid payment attempt with expired credit card'! !

!Cashier class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/9/2013 20:34'!
withPriceCatalog: aPriceCatalog salesBook: aSalesBook andMerchantProcessor: aMerchantProcessor 
	^ self new  initializeWithPriceCatalog: aPriceCatalog salesBook: aSalesBook andMerchantProcessor: aMerchantProcessor 
! !

!Cashier methodsFor: 'apply primitives' stamp: 'EtchegoyenLajePulver 6/9/2013 21:17'!
checkout: aCart withCreditCard: aCreditCard andClient: aClient
	|aSale|
	aCart isEmpty ifTrue: [ ^ Error signal: self class cartEmptyErrorDescription ].
	
	aCreditCard isDue ifTrue: [ ^ Error signal: self class outOfDateCreditCardErrorDescription ].
	
	(aCreditCard name ~= aClient) ifTrue: [ ^ Error signal: self class creditCardNameMismatchDescription ].
	
	aSale := Sale withCart: aCart creditCard: aCreditCard priceCatalog: priceCatalog andClient: aClient.
		
	merchantProcessor debit: aSale amount from: aCreditCard.
		
	salesBook add: aSale.
	^ aSale.! !

!Cashier methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/9/2013 20:36'!
initializeWithPriceCatalog: aPriceCatalog salesBook: aSalesBook andMerchantProcessor: aMerchantProcessor 
	priceCatalog  := aPriceCatalog .
	salesBook := aSalesBook .
	merchantProcessor := aMerchantProcessor .! !

Object subclass: #CreditCard
	instanceVariableNames: 'expirationDate ownerName bin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CreditCard class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/1/2013 17:02'!
createWithExpirationDate: aDate ownerName: aString andBin:  anotherString
	^self new initializeWithExpirationDate: aDate ownerName: aString andBin: anotherString
	! !

!CreditCard methodsFor: 'accessing' stamp: 'EtchegoyenLajePulver 6/9/2013 12:36'!
bin
	^ bin! !

!CreditCard methodsFor: 'accessing' stamp: 'EtchegoyenLajePulver 6/9/2013 11:25'!
expirationDate
	^ expirationDate! !

!CreditCard methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/1/2013 17:02'!
initializeWithExpirationDate: aDate ownerName: aString andBin: anotherString
	expirationDate := aDate.
	ownerName:= aString.
	bin:= anotherString.! !

!CreditCard methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/1/2013 17:20'!
isDue
	^ expirationDate < Date today ! !

!CreditCard methodsFor: 'accessing' stamp: 'EtchegoyenLajePulver 6/1/2013 19:41'!
name 
	^ ownerName! !

Object subclass: #MerchantProcessor
	instanceVariableNames: 'requestsCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!MerchantProcessor class methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 6/9/2013 21:55'!
rejectedOperationDescription
	^ 'Operation rejected'! !

!MerchantProcessor methodsFor: 'apply-primitives' stamp: 'EtchegoyenLajePulver 6/5/2013 20:06'!
debit: aSmallInteger from: aCreditCard 
	self subclassResponsibility ! !

!MerchantProcessor methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/5/2013 20:06'!
initialize 
	requestsCount := 0.! !

!MerchantProcessor methodsFor: 'accessing' stamp: 'EtchegoyenLajePulver 6/5/2013 20:06'!
requestsCount
	^ requestsCount! !

MerchantProcessor subclass: #PermissiveMerchantProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!PermissiveMerchantProcessor methodsFor: 'apply primitives' stamp: 'EtchegoyenLajePulver 6/5/2013 20:16'!
debit: aSmallInteger from: aCreditCard 
	requestsCount := requestsCount +1.
	^ true! !

MerchantProcessor subclass: #ProductionMerchantProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!ProductionMerchantProcessor methodsFor: 'apply-primitives' stamp: 'EtchegoyenLajePulver 6/5/2013 20:07'!
debit: aSmallInteger from: aCreditCard 
	requestsCount := requestsCount +1.
	^ true.! !

MerchantProcessor subclass: #RejectiveMerchantProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!RejectiveMerchantProcessor methodsFor: 'apply-primitives' stamp: 'EtchegoyenLajePulver 6/9/2013 21:55'!
debit: aSmallInteger from: aCreditCard 
	requestsCount := requestsCount +1.
	Error signal: self class rejectedOperationDescription ! !

Object subclass: #ModelInterface
	instanceVariableNames: 'cartsCatalog usersCatalog booksCatalog merchantProcessor salesBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!ModelInterface class methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 6/7/2013 20:56'!
inexistentCartDescription
	^ 'Cart does not exist'.! !

!ModelInterface class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/9/2013 21:10'!
withCartsCatalog: aCartsCatalog usersCatalog: aUsersCatalog booksCatalog: aBooksCatalog andMerchantProcessor: aMerchantProcessor 
	^ self new initializeWithCartsCatalog: aCartsCatalog usersCatalog:  aUsersCatalog booksCatalog: aBooksCatalog andMerchantProcessor: aMerchantProcessor. ! !

!ModelInterface class methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 6/5/2013 21:23'!
wrongUserOrPassword
	^ 'Wrong username or password'! !

!ModelInterface methodsFor: 'apply-primitives' stamp: 'EtchegoyenLajePulver 6/9/2013 21:07'!
add: anIsbn withQuantity: aSmallInteger toCart: aCartId
	| aCart | 
	
	self checkExistingCart: aCartId.
	
	aCart := ((cartsCatalog at: aCartId) at: 2).
	aCart add: anIsbn withOccurrences: aSmallInteger.
	! !

!ModelInterface methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 6/8/2013 19:54'!
checkExistingCart: aCartId
	cartsCatalog at: aCartId ifAbsent: [ ^ Error signal: self class inexistentCartDescription ].! !

!ModelInterface methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/9/2013 21:14'!
checkValidClientid: aClientid andPassword: aPassword
	| exists |
	exists:= usersCatalog at: aClientid ifPresent: [ :value | value = aPassword ] ifAbsent: [ false ].
	exists ifFalse: [ ^ Error signal: self class wrongUserOrPassword ]! !

!ModelInterface methodsFor: 'apply-primitives' stamp: 'EtchegoyenLajePulver 6/9/2013 21:08'!
checkout: aCartId ccn: aCreditCardNumber cced: anExpirationDate cco: aCreditCardOwner
	|aCart aCashier aCreditCard |

	self checkExistingCart: aCartId.
	aCart := ((cartsCatalog at: aCartId) at: 2).

	aCreditCard := CreditCard createWithExpirationDate: anExpirationDate ownerName: aCreditCardOwner andBin:  aCreditCardNumber. 
	aCashier := Cashier withPriceCatalog: booksCatalog salesBook: salesBook andMerchantProcessor: merchantProcessor.
	aCashier checkout: aCart withCreditCard: aCreditCard andClient: aCreditCardOwner.
	
	^ salesBook size
	! !

!ModelInterface methodsFor: 'apply-primitives' stamp: 'EtchegoyenLajePulver 6/9/2013 21:14'!
createCartWithClientid: aClientid andPassword: aPassword
	| aCart aCartId |
	self checkValidClientid: aClientid andPassword: aPassword.
	aCart := Cart withCatalog: booksCatalog.

	aCartId := cartsCatalog size. 	"el catalogo de carritos responde 0,1,2.... Sirve para que cada carrito tenga un Id unico"
	cartsCatalog at: aCartId put: {aClientid. aCart}.
	^ aCartId.! !

!ModelInterface methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/9/2013 21:10'!
initializeWithCartsCatalog: aCartsCatalogue usersCatalog: anUsersCatalogue booksCatalog: aBooksCatalogue andMerchantProcessor: aMerchantProcessor 

	cartsCatalog := aCartsCatalogue.
	usersCatalog := anUsersCatalogue. 
	booksCatalog := aBooksCatalogue.
	merchantProcessor := aMerchantProcessor.
	salesBook := SalesBook new.
	! !

!ModelInterface methodsFor: 'apply-primitives' stamp: 'EtchegoyenLajePulver 6/8/2013 19:54'!
listCart: aCartId
	| aCart aBag |
	
	self checkExistingCart: aCartId.
		
	aBag := Bag new.
	aCart := (cartsCatalog at: aCartId) at: 2.
	^  aCart withItemsAndQuantitiesDo: [:item :quantity | aBag add: item withOccurrences: quantity].! !

!ModelInterface methodsFor: 'apply-primitives' stamp: 'EtchegoyenLajePulver 6/9/2013 21:21'!
listPurchasesFromClient: aClientId withPassword: aPassword
	| sales boughtTotalAmount boughtBooks |
	
	self checkValidClientid: aClientId andPassword: aPassword.
	boughtBooks := Dictionary new.
	boughtTotalAmount := 0.
	
	sales := salesBook purchasesFrom: aClientId.
	sales do: [ :aSale | boughtTotalAmount := boughtTotalAmount + aSale amount.
		aSale cart withItemsAndQuantitiesDo: [ :item :quantity | boughtBooks at: item ifPresent: [ :value | boughtBooks at: item put: value + quantity  ] ifAbsent: [ boughtBooks at: item put: quantity ] ]].
	
	^ { boughtBooks . boughtTotalAmount. }! !

!ModelInterface methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/5/2013 21:21'!
size
	^ cartsCatalog size.! !

Object subclass: #Sale
	instanceVariableNames: 'cart creditCard priceCatalog date client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Sale class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/9/2013 21:18'!
withCart: aCart creditCard: aCreditCard priceCatalog: aPriceCatalog andClient: aClient
	^self new initializeWithCart: aCart creditCard: aCreditCard priceCatalog: aPriceCatalog andClient: aClient! !

!Sale methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/1/2013 17:56'!
amount
	^ cart inject: 0 into: [ :partialSum :item | partialSum + (priceCatalog at: item) ]! !

!Sale methodsFor: 'accessing' stamp: 'EtchegoyenLajePulver 6/9/2013 19:35'!
cart
	^ cart! !

!Sale methodsFor: 'accessing' stamp: 'EtchegoyenLajePulver 6/1/2013 19:24'!
client
	^ client! !

!Sale methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/9/2013 21:18'!
initializeWithCart: aCart creditCard: aCreditCard priceCatalog: aPriceCatalog andClient: aClient
	cart:= aCart.
	creditCard := aCreditCard copy.
	priceCatalog:= aPriceCatalog copy.
	client:= aClient copy.
	date := DateAndTime now.! !

Object subclass: #SalesBook
	instanceVariableNames: 'sales'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!SalesBook methodsFor: 'adding' stamp: 'EtchegoyenLajePulver 6/1/2013 19:17'!
add: aSale
	sales add: aSale! !

!SalesBook methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/1/2013 19:16'!
includes: aSale
	^ sales includes: aSale! !

!SalesBook methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/1/2013 19:15'!
initialize 
	sales:= Set new.! !

!SalesBook methodsFor: 'filtering' stamp: 'EtchegoyenLajePulver 6/1/2013 19:19'!
purchasesFrom: aClient
	^ sales select: [ :aSale | aSale client = aClient ]! !

!SalesBook methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/1/2013 19:16'!
size
	^ sales size! !

Object subclass: #TimedWrapper
	instanceVariableNames: 'timeStamp timeOutSeconds wrappedObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TimedWrapper class methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 6/9/2013 20:27'!
timeOutDescription
	^ 'time out'.! !

!TimedWrapper class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/9/2013 20:29'!
withWrappedObject: anObject TimeStamp: aTimeStamp andTimeOutInSeconds: aNumber
	^ self new initializeWithWrappedObject: anObject TimeStamp: aTimeStamp andTimeOutInSeconds: aNumber! !

!TimedWrapper methodsFor: 'message redirecting' stamp: 'EtchegoyenLajePulver 6/9/2013 20:28'!
doesNotUnderstand: aMessage 
	((TimeStamp now plusSeconds: ( 0-timeOutSeconds)) > timeStamp) ifTrue: [ Error signal: self class timeOutDescription ].
	timeStamp := TimeStamp now.
	aMessage sendTo: wrappedObject ! !

!TimedWrapper methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/9/2013 20:29'!
initializeWithWrappedObject: anObject TimeStamp: aTimeStamp andTimeOutInSeconds: aNumber
	timeStamp := aTimeStamp.
	timeOutSeconds := aNumber.
	wrappedObject:= anObject.! !

!TimedWrapper methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/3/2013 17:45'!
minutesToLive
	^ ((timeStamp asDateAndTime plusSeconds: timeOutSeconds) - DateAndTime now) minutes +1! !

!TimedWrapper methodsFor: 'message redirecting' stamp: 'EtchegoyenLajePulver 6/9/2013 20:28'!
size 
	^ wrappedObject size! !
